﻿@page
@model BeamAndGo.Member.Admin.Web.Pages.CreateMemberModel
@using BeamAndGo.Member;
@{
    ViewData["Title"] = "Create New Member";
}
<body>
    <div class="uk-container uk-container-center">
        <div class="uk-grid-small" uk-grid>
            <div class="uk-width-1-6@m uk-visible@m">
                @{
                    await Html.RenderPartialAsync("_Menu");
                }
            </div>

            <div class="uk-width-expand@m">
                <div class="uk-card uk-card-default uk-card-body">
                    <div class="uk-margin-small">
                        <a class="uk-button uk-button-primary uk-button-small" asp-page="/Member/List">
                            <i class="fas fa-arrow-circle-left"></i><span class="uk-margin-small-left">Return</span>
                        </a>
                    </div>
                    <h3 class="uk-card-title">@ViewData["Title"]</h3>
                    <form asp-page-handler="create" method="post" asp-antiforgery="true" data-ajax-method="post" data-ajax="true" data-ajax-success="createSuccess" data-ajax-failure="createFailed">
                        <div class="uk-margin-small uk-grid-small" uk-grid>
                            <div class="uk-width-1-3@s">
                                <label class="uk-form-label">First Name</label><span class="uk-text-muted uk-text-small"> (Required)</span>
                                <input asp-for="FormData.FirstName" class="uk-input" id="form-stacked-text" type="text" maxlength="128" required>
                                <span asp-validation-for="FormData.FirstName" class="uk-text-danger uk-text-small"></span>
                            </div>

                            <div class="uk-width-1-3@s">
                                <label class="uk-form-label">Middle Name</label>
                                <input asp-for="FormData.MiddleName" class="uk-input" id="form-stacked-text" type="text" maxlength="128">
                                <span asp-validation-for="FormData.MiddleName" class="uk-text-danger uk-text-small"></span>
                            </div>
                            <div class="uk-width-1-3@s">
                                <label class="uk-form-label">Last Name</label><span class="uk-text-muted uk-text-small"> (Required)</span>
                                <input asp-for="FormData.LastName" class="uk-input" id="form-stacked-text" type="text" maxlength="128" required>
                                <span asp-validation-for="FormData.LastName" class="uk-text-danger uk-text-small"></span>
                            </div>
                        </div>
                        <div class="uk-margin-small">
                            <label class="uk-form-label">Display Name/Nickname</label>
                            <input asp-for="FormData.DisplayName" class="uk-input" id="form-stacked-text" type="text" maxlength="128">
                            <span asp-validation-for="FormData.DisplayName" class="uk-text-danger uk-text-small"></span>
                        </div>
                        <div class="uk-margin-small uk-grid-small" uk-grid>
                            <div class="uk-width-1-2@s">
                                <label asp-for="@Model.Birthdate" class="uk-form-label"></label>
                                <input asp-for="@Model.Birthdate" class="uk-input" id="BirthdatePicker" type="date" value="@@Model.BirthDate" min="@Model.MinBirthdate" max="@Model.MaxBirthdate" placeholder="YYYY-MM-DD" />
                                <span asp-validation-for="@Model.Birthdate" class="uk-text-danger uk-text-small"></span>
                            </div>
                            <div class="uk-width-1-2@s">
                                <label asp-for="FormData.Gender" class="uk-form-label"></label>
                                <select class="uk-select" id="createMemberGender" asp-for="@Model.FormData.Gender">
                                    <option selected value=@null disabled>Select Gender</option>
                                    <option value="@(BeamAndGo.Member.GenderType.Female)">Female</option>
                                    <option value="@(BeamAndGo.Member.GenderType.Male)">Male</option>
                                    <option value="@null">Unspecified</option>
                                </select>
                            </div>
                        </div>
                        <div class="uk-margin-small uk-margin-remove-bottom">
                            <label class="uk-form-label">Phone Number</label><span class="uk-text-muted uk-text-small"> (Required)</span>
                        </div>
                        <div class="uk-margin-small uk-margin-remove-top">
                            <input id="create-member-phone" class="uk-input phone-padding-left" type="tel" name="Phone" asp-for="FormData.PhoneNumber" required>
                            <input type="hidden" id="create-member-mobile" asp-for="FormData.PhoneNumber">
                            <input type="hidden" id="create-member-calling-code" asp-for="FormData.CallingCode">
                        </div>
                        <div class="uk-margin-small">
                            <label asp-for="FormData.Email" class="uk-form-label"></label>
                            <input asp-for="FormData.Email" class="uk-input" type="text" />
                            <span asp-validation-for="FormData.Email" class="uk-text-danger uk-text-small"></span>
                        </div>
                        <div class="uk-margin-small">
                            <label class="uk-form-label">Address</label>
                            <textarea asp-for="FormData.Street" class="uk-textarea" rows="2" id="form-stacked-text" type="text"></textarea>
                            <span asp-validation-for="FormData.Street" class="uk-text-danger uk-text-small"></span>
                        </div>
                        <div class="uk-margin-small uk-grid-small" uk-grid>
                            <div class="uk-width-1-2@s">
                                <label class="uk-form-label">Postal Code</label>
                                <input asp-for="FormData.PostalCode" class="uk-input" type="text" />
                                <span asp-validation-for="FormData.PostalCode" class="uk-text-danger uk-text-small"></span>
                            </div>
                            <div class="uk-width-1-2@s">
                                <label class="uk-form-label">Country</label>
                                <input id="create-member-country-code" class="uk-input" type="text" readonly="readonly">
                                <input type="hidden" id="new-create-member-country-code" asp-for="FormData.CountryCode">
                            </div>
                        </div>

                        <div class="uk-margin-large-top">
                            <button id="createBtn" class="uk-button uk-button-primary uk-width-1-1" type="submit">Create New Member</button>
                        </div>
                        <div class="uk-margin-small">
                            <a class="uk-button uk-button-default uk-width-1-1" asp-page="/Member/List"> Cancel </a>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</body>
<style>
    .iti {
        width: 100% !important;
    }

    .country-select {
        width: 100% !important;
    }

    .phone-padding-left {
        padding-left: 90px !important;
    }
</style>
<script>
      //Country
    $(document).ready(function () {
        selectedCountry();
    });

    $("#create-member-country-code").countrySelect({
        preferredCountries: ["au", "ca", "hk", "jp", "my", "ph", "qa", "sa", "sg", "tw", "ae", "us", "gb"],
    });

    function selectedCountry() {
        var country_code = $("#create-member-country-code").countrySelect("getSelectedCountryData");
        $("#new-create-member-country-code").val(country_code.iso2.toUpperCase());
    }

    $("#create-member-country-code").change(function () {
        selectedCountry();
    });

    //Mobile Number
    var input = document.querySelector("#create-member-phone");
    var iti = window.intlTelInput(input, {
        autoPlaceholder: "off",
        separateDialCode: true,
        preferredCountries: ["AU", "CA", "HK", "JP", "MY", "PH", "QA", "SA", "SG", "TW", "AE", "US", "GB"],
        utilsScript:  '@Model.StaticAssetsUrl/js/intl-tel-input/intlTelutils.min.js',
    });

    function handleChange() {
        let country_code = iti.getSelectedCountryData()["dialCode"];
        let number_with_code = iti.getNumber();

        $("#create-member-mobile").val(number_with_code.replace("+" + country_code, ""));
        $("#create-member-calling-code").val(country_code.replace("+", ""));
    }

    // Create Member
    createSuccess = (xhr) => {
        location.href = '/Member/List';
        showSuccessNotification(xhr);
    };
    createFailed = (xhr) => {
        showErrorNotification(xhr.responseText);
    };

    input.addEventListener("countrychange", handleChange);
    input.addEventListener('change', handleChange);
    input.addEventListener('keyup', handleChange);
</script>
